package speiger.src.coreengine.math.vector.bytes;

public record Vec3bImmutable(byte x, byte y, byte z) implements Vec3b {
	
	public Vec3bImmutable() {
		this((byte)0, (byte)0, (byte)0);
	}
	
	public Vec3bImmutable(byte value) {
		this(value, value, value);
	}
		
	@Override
	public boolean isMutable() { return false; }
	@Override
	public Vec3b x(byte x) { return this.x == x ? this : Vec3b.of(x, y, z); }
	@Override
	public Vec3b y(byte y) { return this.y == y ? this : Vec3b.of(x, y, z); }
	@Override
	public Vec3b z(byte z) { return this.z == z ? this : Vec3b.of(x, y, z); }
	@Override
	public Vec3b copy() { return Vec3b.of(this); }
	@Override
	public Vec3b set(byte x, byte y, byte z) { return this.x == x && this.y == y && this.z == z ? this : Vec3b.of(x, y, z); }
}
